import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import au.com.forward.webstringtemplate.*;
/**
 *  An HTTP Servlet that outputs the data definition.
 */
public class Bookstore3Servlet extends HttpServlet {

	public void init() throws ServletException {
		//  use the following lines to dump the cache after 30 secs.
		//  create a new group
		//  WebStringTemplateGroup group = WebStringTemplateServer.getInstanceOfGroup(application,"bookstoreGroup");
		//  set its refresh interval
		//  group.setRefreshInterval(30);
	}

	public void doGet(HttpServletRequest request,
			HttpServletResponse response)
			 throws ServletException, IOException {

		ServletContext application = getServletContext();

		// load the template 'bookstore.st' and the data 'bookstore.data' from the 'st' sub-directory of this application.
		// cache them both in a group called bookstoreGroup.
		WebStringTemplate wst = WebStringTemplateServer.getInstanceOf(application, "bookstoreGroup",
				application.getRealPath("/") + "st", "bookstore");

		// set content-type header before accessing the Writer
		response.setContentType("text/html");
		// set the buffersize from the default data for this template
		response.setBufferSize(wst.getOutputBufferSize());

		PrintWriter out = response.getWriter();
		
		wst.setAttribute("servletRequest",request);
		wst.setAttribute(WebStringTemplate.OUTPUT_DATA_DEFINITION_FLAG,"true");
		wst.setAttribute(WebStringTemplate.OUTPUT_SHOW_ALL_FLAG ,"true");	
		//wst.setAttribute(WebStringTemplate.OUTPUT_SHOW_FILTERS_FLAG,"true");
		
		// then write the data to the response
		wst.write(out);
		out.close();
	}

	public void doPost(HttpServletRequest req, HttpServletResponse resp)
			 throws ServletException, java.io.IOException {
		doGet(req, resp);
	}

	public String getServletInfo() {
		return "A simple WebStringTemplate example that just returns the default data.";
	}
}

